import typing
import decorator

class Working():
    def foo(a: 'Working'):
        pass

print(typing.get_type_hints(Working.foo))        

    
class A():
    pass
    
class WorkingWithDecorator():
    @decorator.my_decorator
    def foo(a: A):
        pass
        
print(typing.get_type_hints(WorkingWithDecorator.foo))
    
    
class NotWorkingWithDecorator():
    @decorator.my_decorator
    def foo(a: 'NotWorkingWithDecorator'):
        pass
        
        
#print(typing.get_type_hints(NotWorkingWithDecorator.foo.__wrapped__)) # this would work
print(typing.get_type_hints(NotWorkingWithDecorator.foo))
